package com.improvess.selecao.model;

import java.io.Serializable;

import javax.persistence.CascadeType;
import javax.persistence.Entity;
import javax.persistence.GeneratedValue;
import javax.persistence.GenerationType;
import javax.persistence.Id;
import javax.persistence.OneToOne;
import javax.persistence.Table;

import com.improvess.selecpos.model.Anexo;
import com.improvess.selecpos.model.Area;
import com.improvess.selecpos.model.AvaliacaoDoutorado;
import com.improvess.selecpos.model.AvaliacaoPreProjeto;

@SuppressWarnings("serial")
@Entity
@Table(name = "Doutorado")
public class Doutorado implements Serializable {

	@Id
	@GeneratedValue(strategy = GenerationType.AUTO)
	private Long id;

	@OneToOne
	private Area area;
	private String orientador;
	private String titulo;
	private String projeto;
	@OneToOne(cascade = CascadeType.ALL)
	private Anexo anexo;
	@OneToOne(cascade = CascadeType.ALL)
	private AvaliacaoPreProjeto avaliacaoPreProjeto;
	@OneToOne(cascade = CascadeType.ALL)
	private AvaliacaoDoutorado avaliacaoDoutoradoCVUm;
	@OneToOne(cascade = CascadeType.ALL)
	private AvaliacaoDoutorado avaliacaoDoutoradoCVDois;

	public Doutorado() {
	}

	public Long getId() {
		return id;
	}

	public void setId(Long id) {
		this.id = id;
	}

	public Area getArea() {
		return area;
	}

	public void setArea(Area area) {
		this.area = area;
	}

	public String getOrientador() {
		return orientador;
	}

	public void setOrientador(String orientador) {
		this.orientador = orientador;
	}

	public String getProjeto() {
		return projeto;
	}

	public void setProjeto(String projeto) {
		this.projeto = projeto;
	}

	public void setTitulo(String titulo) {
		this.titulo = titulo;
	}

	public String getTitulo() {
		return titulo;
	}

	public Anexo getAnexo() {
		return anexo;
	}

	public void setAnexo(Anexo anexo) {
		this.anexo = anexo;
	}

	public void setAvaliacaoPreProjeto(AvaliacaoPreProjeto avaliacaoPreProjeto) {
		this.avaliacaoPreProjeto = avaliacaoPreProjeto;
	}

	public AvaliacaoPreProjeto getAvaliacaoPreProjeto() {
		return avaliacaoPreProjeto;
	}

	public void setAvaliacaoDoutoradoCVUm(AvaliacaoDoutorado avaliacaoDoutoradoCVUm) {
		this.avaliacaoDoutoradoCVUm = avaliacaoDoutoradoCVUm;
	}

	public AvaliacaoDoutorado getAvaliacaoDoutoradoCVUm() {
		return avaliacaoDoutoradoCVUm;
	}

	public void setAvaliacaoDoutoradoCVDois(AvaliacaoDoutorado avaliacaoDoutoradoCVDois) {
		this.avaliacaoDoutoradoCVDois = avaliacaoDoutoradoCVDois;
	}

	public AvaliacaoDoutorado getAvaliacaoDoutoradoCVDois() {
		return avaliacaoDoutoradoCVDois;
	}

	
}
