package com.improvess.selecao.model;

import java.io.Serializable;
import java.math.BigDecimal;

import javax.persistence.CascadeType;
import javax.persistence.Entity;
import javax.persistence.GeneratedValue;
import javax.persistence.GenerationType;
import javax.persistence.Id;
import javax.persistence.OneToOne;
import javax.persistence.Table;

import com.improvess.selecpos.model.Anexo;
import com.improvess.selecpos.model.Area;
import com.improvess.selecpos.model.AvaliacaoMestrado;
import com.improvess.selecpos.model.AvaliacaoPreProjeto;

@SuppressWarnings("serial")
@Entity
@Table(name = "Mestrado")
public class Mestrado implements Serializable {

	@Id
	@GeneratedValue(strategy = GenerationType.AUTO)
	private Long id;

	@OneToOne
	private Area opcaoUmArea;
	private String opcaoUmTitulo;
	@OneToOne(cascade = CascadeType.ALL)
	private Anexo opcaoUmProjeto;
	@OneToOne(cascade = CascadeType.ALL)
	private AvaliacaoPreProjeto avaliacaoPreProjetoUm;

	@OneToOne
	private Area opcaoDoisArea;
	private String opcaoDoisTitulo;
	@OneToOne(cascade = CascadeType.ALL)
	private Anexo opcaoDoisProjeto;
	@OneToOne(cascade = CascadeType.ALL)
	private AvaliacaoPreProjeto avaliacaoPreProjetoDois;

	@OneToOne(cascade = CascadeType.ALL)
	private AvaliacaoMestrado avaliacaoMestradoCVUm;

	@OneToOne(cascade = CascadeType.ALL)
	private AvaliacaoMestrado avaliacaoMestradoCVDois;

	public Mestrado() {
	}

	public BigDecimal getNotaMaior() {
		BigDecimal retorno = null;
		if (this.avaliacaoPreProjetoUm != null) {
			if (this.avaliacaoPreProjetoDois != null) {
				if (this.avaliacaoPreProjetoDois.getNotaFinal().compareTo(
						this.avaliacaoPreProjetoUm.getNotaFinal()) > 0) {
					retorno = this.avaliacaoPreProjetoDois.getNotaFinal();
				} else {
					retorno = this.avaliacaoPreProjetoUm.getNotaFinal();
				}
			} else {
				retorno = this.avaliacaoPreProjetoUm.getNotaFinal();
			}
		}
		return retorno;
	}

	public Long getId() {
		return id;
	}

	public void setId(Long id) {
		this.id = id;
	}

	public Area getOpcaoUmArea() {
		return opcaoUmArea;
	}

	public void setOpcaoUmArea(Area opcaoUmArea) {
		this.opcaoUmArea = opcaoUmArea;
	}

	public String getOpcaoUmTitulo() {
		return opcaoUmTitulo;
	}

	public void setOpcaoUmTitulo(String opcaoUmTitulo) {
		this.opcaoUmTitulo = opcaoUmTitulo;
	}

	public Anexo getOpcaoUmProjeto() {
		return opcaoUmProjeto;
	}

	public void setOpcaoUmProjeto(Anexo opcaoUmProjeto) {
		this.opcaoUmProjeto = opcaoUmProjeto;
	}

	public Area getOpcaoDoisArea() {
		return opcaoDoisArea;
	}

	public void setOpcaoDoisArea(Area opcaoDoisArea) {
		this.opcaoDoisArea = opcaoDoisArea;
	}

	public String getOpcaoDoisTitulo() {
		return opcaoDoisTitulo;
	}

	public void setOpcaoDoisTitulo(String opcaoDoisTitulo) {
		this.opcaoDoisTitulo = opcaoDoisTitulo;
	}

	public Anexo getOpcaoDoisProjeto() {
		return opcaoDoisProjeto;
	}

	public void setOpcaoDoisProjeto(Anexo opcaoDoisProjeto) {
		this.opcaoDoisProjeto = opcaoDoisProjeto;
	}

	public void setAvaliacaoPreProjetoUm(
			AvaliacaoPreProjeto avaliacaoPreProjetoUm) {
		this.avaliacaoPreProjetoUm = avaliacaoPreProjetoUm;
	}

	public AvaliacaoPreProjeto getAvaliacaoPreProjetoUm() {
		return avaliacaoPreProjetoUm;
	}

	public void setAvaliacaoPreProjetoDois(
			AvaliacaoPreProjeto avaliacaoPreProjetoDois) {
		this.avaliacaoPreProjetoDois = avaliacaoPreProjetoDois;
	}

	public AvaliacaoPreProjeto getAvaliacaoPreProjetoDois() {
		return avaliacaoPreProjetoDois;
	}

	public void setAvaliacaoMestradoCVDois(
			AvaliacaoMestrado avaliacaoMestradoCVDois) {
		this.avaliacaoMestradoCVDois = avaliacaoMestradoCVDois;
	}

	public AvaliacaoMestrado getAvaliacaoMestradoCVDois() {
		return avaliacaoMestradoCVDois;
	}

	public void setAvaliacaoMestradoCVUm(AvaliacaoMestrado avaliacaoMestradoCVUm) {
		this.avaliacaoMestradoCVUm = avaliacaoMestradoCVUm;
	}

	public AvaliacaoMestrado getAvaliacaoMestradoCVUm() {
		return avaliacaoMestradoCVUm;
	}

	public BigDecimal getNotaPreProjetoUm() {
		BigDecimal retorno = null;

		if (this.getAvaliacaoPreProjetoUm() != null) {
			retorno = this.getAvaliacaoPreProjetoUm().getNotaFinal();
		}

		return retorno;
	}

	public BigDecimal getNotaPreProjetoDois() {
		BigDecimal retorno = null;

		if (this.getAvaliacaoPreProjetoDois() != null) {
			retorno = this.getAvaliacaoPreProjetoDois().getNotaFinal();
		}

		return retorno;
	}
}
