package com.improvess.selecpos.model;

import java.io.Serializable;
import java.util.Date;

import javax.persistence.Column;
import javax.persistence.Entity;
import javax.persistence.GeneratedValue;
import javax.persistence.GenerationType;
import javax.persistence.Id;
import javax.persistence.ManyToOne;
import javax.persistence.OneToOne;
import javax.persistence.Table;

import com.improvess.selecao.model.Candidato;

@SuppressWarnings("serial")
@Entity
@Table(name = "alocacao")
public class Alocacao implements Serializable {

	@Id
	@GeneratedValue(strategy = GenerationType.AUTO)
	private Long id;

	@OneToOne
	private Candidato candidato;

	@ManyToOne
	private Docente avaliadorUm;

	@Column(name="dataAlocacaoUm")
	private Date dataAlocacaoUm;

	@ManyToOne
	private Docente avaliadorDois;

	@Column(name="dataAlocacaoDois")
	private Date dataAlocacaoDois;

	public Docente getAvaliadorUm() {
		return avaliadorUm;
	}

	public void setAvaliadorUm(Docente avaliadorUm) {
		this.avaliadorUm = avaliadorUm;
	}

	public Long getId() {
		return id;
	}

	public void setId(Long id) {
		this.id = id;
	}

	public Candidato getCandidato() {
		return candidato;
	}

	public void setCandidato(Candidato candidato) {
		this.candidato = candidato;
	}

	public void setDataAlocacaoUm(Date dataAlocacaoUm) {
		this.dataAlocacaoUm = dataAlocacaoUm;
	}

	public Date getDataAlocacaoUm() {
		return dataAlocacaoUm;
	}

	public Docente getAvaliadorDois() {
		return avaliadorDois;
	}

	public void setAvaliadorDois(Docente avaliadorDois) {
		this.avaliadorDois = avaliadorDois;
	}

	public Date getDataAlocacaoDois() {
		return dataAlocacaoDois;
	}

	public void setDataAlocacaoDois(Date dataAlocacaoDois) {
		this.dataAlocacaoDois = dataAlocacaoDois;
	}

	@Override
	public boolean equals(Object obj) {
		boolean retorno = false;
		if (obj instanceof Alocacao) {
			Alocacao alocacao = (Alocacao) obj;
			retorno = this.getCandidato() != null
					&& this.getCandidato().equals(alocacao.getCandidato());
		}
		return retorno;
	}

	@Override
	public int hashCode() {
		int retorno = 0;
		if (this.candidato != null) {
			retorno = this.candidato.hashCode();
		}
		return retorno;
	}

}
