package com.improvess.selecpos.model;

import java.io.Serializable;

import javax.persistence.Column;
import javax.persistence.Entity;
import javax.persistence.GeneratedValue;
import javax.persistence.GenerationType;
import javax.persistence.Id;
import javax.persistence.ManyToOne;
import javax.persistence.Table;

@SuppressWarnings("serial")
@Entity
@Table(name = "area")
public class Area implements Serializable {

	@Id
	@GeneratedValue(strategy = GenerationType.AUTO)
	private Long id;

	@Column(name = "nome", nullable=false, length=255)
	private String nome;
	
	@ManyToOne
	private Area areaAssociada;

	public Long getId() {
		return id;
	}

	public void setId(Long id) {
		this.id = id;
	}

	public String getNome() {
		return nome;
	}

	public void setNome(String nome) {
		this.nome = nome;
	}
	
	public Area getAreaAssociada() {
		return areaAssociada;
	}
	
	public void setAreaAssociada(Area areaAssociada) {
		this.areaAssociada = areaAssociada;
	}
	
	public String getDescricao(){
		String retorno = this.getNome();
		if(this.areaAssociada != null){
			retorno = this.areaAssociada.getDescricao() + " | " + retorno;
		}
		return retorno;
	}

	@Override
	public boolean equals(Object obj) {
		boolean retorno = false;
		if (obj instanceof Area) {
			Area area = (Area) obj;
			retorno = this.nome != null
					&& this.nome.equalsIgnoreCase(area.nome);
		}
		return retorno;
	}

	@Override
	public int hashCode() {
		int retorno = 0;
		if (this.nome != null) {
			retorno = this.nome.hashCode();
		}
		return retorno;
	}

}
