package com.improvess.selecpos.model;

import java.io.Serializable;
import java.math.BigDecimal;

import javax.persistence.Entity;
import javax.persistence.EnumType;
import javax.persistence.Enumerated;
import javax.persistence.GeneratedValue;
import javax.persistence.GenerationType;
import javax.persistence.Id;
import javax.persistence.Table;

@SuppressWarnings("serial")
@Entity
@Table(name = "avaliacaoPublicacao")
public class AvaliacaoPublicacao implements Serializable,
		Comparable<AvaliacaoPublicacao> {

	@Id
	@GeneratedValue(strategy = GenerationType.AUTO)
	private Long id;
	private String tituloPublicacao;
	@Enumerated(EnumType.STRING)
	private ExtratoQualis extratoQualis;
	@Enumerated(EnumType.STRING)
	private OrdemAutores ordemAutores;
	@Enumerated(EnumType.STRING)
	private TipoPublicacao tipoPublicacao;

	public ExtratoQualis getExtratoQualis() {
		return extratoQualis;
	}

	public void setExtratoQualis(ExtratoQualis extratoQualis) {
		this.extratoQualis = extratoQualis;
	}

	public OrdemAutores getOrdemAutores() {
		return ordemAutores;
	}

	public void setOrdemAutores(OrdemAutores ordemAutores) {
		this.ordemAutores = ordemAutores;
	}

	public TipoPublicacao getTipoPublicacao() {
		return tipoPublicacao;
	}

	public void setTipoPublicacao(TipoPublicacao tipoPublicacao) {
		this.tipoPublicacao = tipoPublicacao;
	}

	public String getTituloPublicacao() {
		return tituloPublicacao;
	}

	public void setTituloPublicacao(String tituloPublicacao) {
		this.tituloPublicacao = tituloPublicacao;
	}

	public void setId(Long id) {
		this.id = id;
	}

	public Long getId() {
		return id;
	}

	@Override
	public int compareTo(AvaliacaoPublicacao outra) {
		int retorno;

		if (this.extratoQualis == outra.extratoQualis) {
			if (this.ordemAutores == outra.ordemAutores) {
				retorno = 0;
			} else if (this.ordemAutores == OrdemAutores.PRIMEIRO) {
				retorno = -1;
			} else {
				retorno = 1;
			}
		} else if (this.extratoQualis == ExtratoQualis.A1) {
			retorno = -1;
		} else if (outra.extratoQualis == ExtratoQualis.A1) {
			retorno = 1;
		} else if (this.extratoQualis == ExtratoQualis.A2) {
			retorno = -1;
		} else if (outra.extratoQualis == ExtratoQualis.A2) {
			retorno = 1;
		} else if (this.extratoQualis == ExtratoQualis.B1) {
			retorno = -1;
		} else if (outra.extratoQualis == ExtratoQualis.B1) {
			retorno = 1;
		} else if (this.extratoQualis == ExtratoQualis.B2) {
			retorno = -1;
		} else if (outra.extratoQualis == ExtratoQualis.B2) {
			retorno = 1;
		} else if (this.extratoQualis == ExtratoQualis.B3) {
			retorno = -1;
		} else if (outra.extratoQualis == ExtratoQualis.B3) {
			retorno = 1;
		} else if (this.extratoQualis == ExtratoQualis.B4) {
			retorno = -1;
		} else if (outra.extratoQualis == ExtratoQualis.B4) {
			retorno = 1;
		} else if (this.extratoQualis == ExtratoQualis.B5) {
			retorno = -1;
		} else {
			retorno = 1;
		}

		return retorno;
	}

	public BigDecimal getValor() {
		BigDecimal retorno = this.extratoQualis.getValor();

		if (this.ordemAutores == OrdemAutores.SEGUNDO) {
			retorno = retorno.divide(Avaliacao.DOIS);
		}
		return retorno;
	}
}
