package com.improvess.selecpos.model;

import java.io.Serializable;

import javax.persistence.Column;
import javax.persistence.Entity;
import javax.persistence.GeneratedValue;
import javax.persistence.GenerationType;
import javax.persistence.Id;
import javax.persistence.ManyToOne;
import javax.persistence.Table;

@SuppressWarnings("serial")
@Entity
@Table(name = "docente")
public class Docente implements Serializable {

	@Id
	@GeneratedValue(strategy = GenerationType.AUTO)
	private Long id;

	@Column(name = "login", nullable = false, length = 50)
	private String login;

	@Column(name = "nome", nullable = false, length = 255)
	private String nome;

	@Column(name = "email", nullable = false, length = 50)
	private String email;

	@Column(name = "cpf", nullable = false, length = 11)
	private String cpf;

	@ManyToOne
	private AreaSiga areaSiga;

	public String getLogin() {
		return login;
	}

	public void setLogin(String login) {
		this.login = login;
	}

	public String getNome() {
		return nome;
	}

	public void setNome(String nome) {
		this.nome = nome;
	}

	public String getEmail() {
		return email;
	}

	public void setEmail(String email) {
		this.email = email;
	}

	public String getCpf() {
		return cpf;
	}

	public void setCpf(String cpf) {
		this.cpf = cpf;
	}

	public AreaSiga getAreaSiga() {
		return areaSiga;
	}

	public void setAreaSiga(AreaSiga areaSiga) {
		this.areaSiga = areaSiga;
	}

	public Long getId() {
		return id;
	}

	public void setId(Long id) {
		this.id = id;
	}

	@Override
	public boolean equals(Object obj) {
		boolean retorno = false;
		if (obj instanceof Docente) {
			Docente docente = (Docente) obj;
			retorno = this.cpf != null
					&& this.cpf.equalsIgnoreCase(docente.cpf);
		}
		return retorno;
	}

	@Override
	public int hashCode() {
		int retorno = 0;
		if (this.cpf != null) {
			retorno = this.cpf.hashCode();
		}
		return retorno;
	}

}
