package com.improvess.selecpos.model;

import java.io.Serializable;

import javax.persistence.Column;
import javax.persistence.Entity;
import javax.persistence.GeneratedValue;
import javax.persistence.GenerationType;
import javax.persistence.Id;
import javax.persistence.Table;
@SuppressWarnings("serial")
@Entity
@Table(name = "etapa")
public class Etapa implements Serializable {
	
	@Id
	@GeneratedValue(strategy = GenerationType.AUTO)
	private Long id;

	@Column(name = "nome", nullable=false, length=255)
	private String nome;

	@Column(name = "habilitada")
	private Boolean habilitada;

	public Long getId() {
		return id;
	}

	public void setId(Long id) {
		this.id = id;
	}

	public String getNome() {
		return nome;
	}

	public void setNome(String nome) {
		this.nome = nome;
	}

	public Boolean getHabilitada() {
		return habilitada;
	}

	public void setHabilitada(Boolean habilitada) {
		this.habilitada = habilitada;
	}

	@Override
	public boolean equals(Object obj) {
		boolean retorno = false;
		if (obj instanceof Etapa) {
			Etapa etapa = (Etapa) obj;
			retorno = this.nome != null
					&& this.nome.equalsIgnoreCase(etapa.nome);
		}
		return retorno;
	}

	@Override
	public int hashCode() {
		int retorno = 0;
		if (this.nome != null) {
			retorno = this.nome.hashCode();
		}
		return retorno;
	}

}
