package com.improvess.selecpos.model;

import java.io.Serializable;
import java.util.List;

import javax.persistence.CascadeType;
import javax.persistence.Column;
import javax.persistence.Entity;
import javax.persistence.FetchType;
import javax.persistence.GeneratedValue;
import javax.persistence.GenerationType;
import javax.persistence.Id;
import javax.persistence.ManyToMany;
import javax.persistence.ManyToOne;
import javax.persistence.OneToOne;
import javax.persistence.Table;

@SuppressWarnings("serial")
@Entity
@Table(name = "tema")
public class Tema implements Serializable {

	@Id
	@GeneratedValue(strategy = GenerationType.AUTO)
	private Long id;

	@ManyToOne
	private Docente docente;

	@ManyToMany(fetch = FetchType.EAGER)
	private List<Area> areas;

	@Column(name = "titulo", nullable=false, length=255)
	private String titulo;

	@Column(name = "tipocurso")
	private TipoCurso tipoCurso;

	@OneToOne(cascade=CascadeType.ALL, fetch=FetchType.LAZY)
	@org.hibernate.annotations.Cascade(value=org.hibernate.annotations.CascadeType.DELETE_ORPHAN)
	private Anexo anexo;

	@Column(name = "nomeanexo", length=255)
	private String nomeAnexo;
	
	public Long getId() {
		return id;
	}

	public void setId(Long id) {
		this.id = id;
	}

	public Docente getDocente() {
		return docente;
	}

	public void setDocente(Docente docente) {
		this.docente = docente;
	}

	public List<Area> getAreas() {
		return areas;
	}

	public void setAreas(List<Area> areas) {
		this.areas = areas;
	}

	public String getTitulo() {
		return titulo;
	}

	public void setTitulo(String titulo) {
		this.titulo = titulo;
	}

	public TipoCurso getTipoCurso() {
		return tipoCurso;
	}

	public void setTipoCurso(TipoCurso tipoCurso) {
		this.tipoCurso = tipoCurso;
	}

	public Anexo getAnexo() {
		return anexo;
	}

	public void setAnexo(Anexo anexo) {
		this.anexo = anexo;
		if(this.anexo != null){
			this.nomeAnexo = this.anexo.getNome();
		}
	}
	
	public String getNomeAnexo() {
		return nomeAnexo;
	}
	
	public void setNomeAnexo(String nomeAnexo) {
		this.nomeAnexo = nomeAnexo;
	}

	@Override
	public boolean equals(Object obj) {
		boolean retorno = false;
		if (obj instanceof Tema) {
			Tema tema = (Tema) obj;
			retorno = this.titulo != null
					&& this.titulo.equalsIgnoreCase(tema.titulo);
		}
		return retorno;
	}

	@Override
	public int hashCode() {
		int retorno = 0;
		if (this.titulo != null) {
			retorno = this.titulo.hashCode();
		}
		return retorno;
	}

}
