package com.improvess.selecpos.model;

import java.io.Serializable;

import javax.persistence.Column;
import javax.persistence.Entity;
import javax.persistence.GeneratedValue;
import javax.persistence.GenerationType;
import javax.persistence.Id;
import javax.persistence.Table;

@SuppressWarnings("serial")
@Entity
@Table(name = "usuario")
public class Usuario implements Serializable {

	@Id
	@GeneratedValue(strategy = GenerationType.AUTO)
	private Long id;

	@Column(name = "nome", nullable=false, length=255)
	private String nome;

	@Column(name = "perfil")
	private Perfil perfil;

	@Column(name = "cargo", nullable=false, length=255)
	private String cargo;

	@Column(name = "login", nullable=false, length=50)
	private String login;

	public Usuario() {

	}

	public Long getId() {
		return id;
	}

	public void setId(Long id) {
		this.id = id;
	}

	public String getNome() {
		return nome;
	}

	public void setNome(String nome) {
		this.nome = nome;
	}

	public Perfil getPerfil() {
		return perfil;
	}

	public void setPerfil(Perfil perfil) {
		this.perfil = perfil;
	}

	public String getCargo() {
		return cargo;
	}

	public void setCargo(String cargo) {
		this.cargo = cargo;
	}

	public String getLogin() {
		return login;
	}

	public void setLogin(String login) {
		this.login = login;
	}
	
	@Override
	public boolean equals(Object obj) {
		boolean retorno = false;
		if (obj instanceof Usuario) {
			Usuario usuario = (Usuario) obj;
			retorno = this.login != null && this.login.equalsIgnoreCase(usuario.login);
		}
		return retorno;
	}
	
	@Override
	public int hashCode() {
		int retorno = 0;
		if(this.login != null){
			retorno = this.login.hashCode();
		}
		return retorno;
	}

}
